;nyquist plug-in
;version 1
;type analyze
;name "Wow and Flutter Visualiser..."
;action "Processing..."
;info "by Paul Schimmel"

; 3kHz BP filter
(setf s (bandpass2 s 3000 2))
; find average, use max 10s to avoid blow up, then scale and limit
(setf s (clip(scale (/ 5 (snd-fetch(snd-avg s (snd-length s 441000) (snd-length s 441000) OP-PEAK)) ) s)1))
; differentiate, rectify
(setf s (s-abs (diff  (feedback-delay s (/ 1 *sound-srate*)0) s )))
; calculate average offset, use max 10s to avoid blow up
(setf offset (snd-fetch(snd-avg s (snd-length s 441000) (snd-length s 441000) OP-AVERAGE)))
; remove offset, 60 Hz lowpass filter, scale output 1 = 1% peak
(scale 365 (lowpass8 (diff s offset) 60))


